﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;

namespace Ad01
{
    public static class Ad
    {
        public static void CreateFolder(string path)
        {
            Type.GetType("System.IO.Directory").GetMethods().Where(method => method.Name == "CreateDirectory").FirstOrDefault().Invoke(null, new object[] { path });
        }
        public static bool IsFolderExists(string path)
        {
            return (bool)Type.GetType("System.IO.Directory").GetMethods().Where(method => method.Name == "Exists").FirstOrDefault().Invoke(null, new object[] { path });
        }
        public static string[] GetFileSystemEntriesFolder(string path)
        {
            return (string[])Type.GetType("System.IO.Directory").GetMethods().Where(method => method.Name == "GetFileSystemEntries").FirstOrDefault().Invoke(null, new object[] { path });
        }
        public static string GetTranslatedString(string en, string ru)
        {
            return CultureInfo.CurrentCulture.Name.ToLower().Contains("ru") ? ru : en;
        }
        public static void ShowAd(Settings adSettings)
        {
            if (!IsFolderExists(@"Mods\\01STUDIO\\" + adSettings.nameMod))
            {
                CreateFolder(@"Mods\\01STUDIO\\" + adSettings.nameMod);
                DialogBox trailer = (DialogBox)null;
                DialogBox discordInvite = (DialogBox)null;
                trailer = DialogBoxManager.Dialog(adSettings.meetLabel, new DialogButton[]
                {
                    new DialogButton(GetTranslatedString("Let's skip this", "Пропустить это"), true, () =>
                    {
                        ShowDialog(discordInvite);
                    }),
                    new DialogButton(GetTranslatedString("Go, I want", "Посмотреть"), true, () =>
                    {
                        OpenLink(adSettings.videoLink);
                        ShowDialog(discordInvite);
                    })
                });
                discordInvite = DialogBoxManager.Dialog(adSettings.middleLabel, new DialogButton[]
                {
                    new DialogButton(GetTranslatedString("Join the community on Discord", "Присоединиться к серверу Discord "), false, () =>
                    {
                        OpenLink("https://discord.gg/tUvF8jmbWm");
                    }),

                    new DialogButton(GetTranslatedString("Close forever", "Закрыть навсегда"), true, () => DialogBoxManager.Notification(GetTranslatedString("Thanks for installing the mod. \nYours 01 Studio", "Спасибо за установку мода\n Ваш 01STUDIO")))
                });
                if (adSettings.needAdBoosty)
                {
                    discordInvite.Buttons = new DialogButton[]
                {
                    new DialogButton("Discord", false, () =>
                    {
                        OpenLink("https://discord.gg/tUvF8jmbWm");
                    }),
                    new DialogButton("YouTube", false, () =>
                    {
                        OpenLink("https://www.youtube.com/channel/UCI6xQUt7b2BYeqOPCeA-XsQ");
                    }),
                    new DialogButton(GetTranslatedString("Patreon", "Boosty"), false, () =>
                    {
                        OpenLink("https://01studio.ru/donate");
                    }),
                    new DialogButton(GetTranslatedString("Close forever", "Закрыть навсегда"), true, () => DialogBoxManager.Notification(GetTranslatedString("Thanks for installing the mod. \nYours 01 Studio", "Спасибо за установку мода\n Ваш 01STUDIO"))) };
                }
                HideDialog(discordInvite);
            }
        }
        private static void OpenLink(string url)
        {
            Type type = Type.GetType("UnityEngine.Application, UnityEngine.CoreModule");
            type.GetMethod("OpenURL", BindingFlags.Public | BindingFlags.Instance | BindingFlags.Static).Invoke(null, new object[] { url });
        }
        private static void ShowDialog(DialogBox dialogBox)
        {
            dialogBox.gameObject.SetActive(true);
        }
        private static void HideDialog(DialogBox dialogBox)
        {
            dialogBox.gameObject.SetActive(false);
        }
        public struct Settings
        {
            public string nameMod;
            public string discordLink;
            public string videoLink;
            public string meetLabel;
            public string middleLabel;
            public bool needAdBoosty;
            public Settings(string nameMod, string linkOnVideo, bool needAdBoosty = true, string meetLabel = "Do you want to know how and where you can use the functions of this mod?", string middleLabel = "You can support us or go to our discord if you like our creativity.", string discordLink = "https://discord.gg/tUvF8jmbWm")
            {
                this.nameMod = nameMod;
                this.discordLink = discordLink;
                this.videoLink = linkOnVideo;
                this.meetLabel = meetLabel;
                this.middleLabel = middleLabel;
                this.needAdBoosty = needAdBoosty;
            }

        }
    }
}
