using Ad01;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Threading.Tasks;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
using UnityEngine.Video;
using Utility01;

namespace StrangePlayground
{
    public class Mod
    {
        public static AudioClip au = ModAPI.LoadSound("Idi.mp3");
        public static AudioClip among = ModAPI.LoadSound("among.mp3");
        public static AudioClip bad = ModAPI.LoadSound("bad-to-the-bone.mp3");
        public static AudioClip bird = ModAPI.LoadSound("bird.mp3");
        public static AudioClip ben = ModAPI.LoadSound("talking-ben-saying-ben.mp3");
        public static AudioClip mov = ModAPI.LoadSound("movie_1.mp3");
        public static AudioClip record = ModAPI.LoadSound("record-scratch.mp3");
        public static AudioClip wilhelmscream = ModAPI.LoadSound("wilhelmscream.mp3");
        public static AudioClip AAA = ModAPI.LoadSound("BackFone.mp3");
        public static List<Color> color = new List<Color>();
        public static List<Liquid> liquids = new List<Liquid>();
        public static SpawnableAsset[] spawnableAssets = Resources.LoadAll<SpawnableAsset>("SpawnableAssets");
        public static Dictionary<string, Sprite> sprites = new Dictionary<string, Sprite>()
        {
            { "panels", ModAPI.LoadSprite("panels.png") }
        };
        public static void OnLoad()
        {
            Utility.ModMetaCache(ModAPI.Metadata.MetaLocation);
            if (!Utility.IsFolderExists(@"Mods\\01STUDIO\\Strange Playground Disclaimer"))
            {
                DialogBox disclaimer = null;
                DialogBoxManager.Main.DialogBoxPrefab.transform.localScale = new Vector3(1.6f, 2.1f);
                disclaimer = DialogBoxManager.Dialog($"<align=\"center\"><size=300%><color=\"red\">{Utility.GetTranslatedString("Disclaimer", "Внимание")}<color=\"white\"><size=90%><align=\"left\">\n{Utility.GetTranslatedString("This mod contains abrupt changes of colors, sounds, flashes, which can cause a seizure in epileptic patients.", "Этот мод содержит резкие изменения цветов, звуков, вспышек, \nкоторые могут вызвать припадок у больных эпилепсией.")} \n{Utility.GetTranslatedString("We also advise you to watch the video trailer that will be offered for viewing further", "Мы также советуем вам посмотреть видео-трейлер, который будет предложен для дальнейшего просмотра.")}\n{Utility.GetTranslatedString("Confirm that you have read this information, with care 01 STUDIO.", "Подтвердите ознакомление с данной информацией, с заботой 01 STUDIO.")}", new DialogButton[]
                {
                new DialogButton(Utility.GetTranslatedString("Cancel", "Отменить"), true, () =>
                {
                    disclaimer.Close();
                }),
                new DialogButton(Utility.GetTranslatedString("Confirm", "Подтвердить"), true, () =>
                {
                    Utility.CreateFolder(@"Mods\\01STUDIO\\Strange Playground Disclaimer");
                    ShowAd();
                    SuccessfulLoad();
                    disclaimer.Close();
                })
                });
                DialogBoxManager.Main.DialogBoxPrefab.transform.localScale = new Vector3(1, 1);
            }
            else
            {
                ShowAd();
                SuccessfulLoad();
            }
        }
        public static void ShowAd()
        {
            Ad.ShowAd(new Ad.Settings("StrangePlayground", "https://youtu.be/8LCSY9tLSGM", true, Utility.GetTranslatedString("Before launching the mod, we strongly recommend that you familiarize yourself with the trailer. And also subscribe to the channel :)\nOnly this gives us the opportunity to work more and further!", "Перед запуском мода, мы настоятельно рекомендуем ознакомиться с трейлером. А также подписаться на канал :)\nТолько это даёт нам возможность работать больше и дальше!"), Utility.GetTranslatedString("I will be very glad if you join our discord server, here I can help you if there are problems with the mod!\nI will also be very glad if you support me.", "Буду очень рад если вы присоединитесь к нашему дискорд серверу, здесь я смогу помочь вам если возникнут проблемы с модом!\nТакже буду очень рад, если вы поддержите меня.")));

        }
        private static void SuccessfulLoad()
        {
            StrangeController.Initialize();
            Stranger.StrangeAll();
            Map map = ScriptableObject.CreateInstance<Map>();
            map.name = "Strange";
            map.UniqueIdentity = Guid.NewGuid().ToString();
            map.Description = "st ra ng e";
            map.Thumbnail = Utility.LoadSprite("mapIcon.png");
            map.Preview = Utility.LoadSprite("mapIcon.png");
            map.Prefab = MapRegistry.GetMap("fb813068-e717-45de-a97f-4677a41758e6").Prefab;
            map.Prefab.transform.Find("Light").gameObject.AddComponent<StrangeMapLight>();
            MapRegistry.Register(map);
            ModAPI.FindSpawnable("Sword").Prefab.AddComponent<StrangeSharp>();
            ModAPI.FindSpawnable("Spike").Prefab.AddComponent<StrangeSharp>();
            ModAPI.FindSpawnable("Spear").Prefab.AddComponent<StrangeSharp>();
            ModAPI.FindSpawnable("Lance").Prefab.AddComponent<StrangeSharp>();
            ModAPI.FindSpawnable("Knife").Prefab.AddComponent<StrangeSharp>();
            ModAPI.FindSpawnable("Crystal").Prefab.AddComponent<StrangeSharp>();
            ModAPI.FindSpawnable("Crossbow Bolt").Prefab.AddComponent<StrangeSharp>();
            var axePrefab = ModAPI.FindSpawnable("Axe").Prefab;
            axePrefab.transform.Find("Axe handle/Axe head").gameObject.AddComponent<StrangeSharp>();

            for (int i = 0; i < 25; i++)
            {
                Mod.color.Add(UnityEngine.Color.Lerp(UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.85f), UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.85f), 1));
                int index = i; float r = 1; float g = 1; float b = 1; float i1 = UnityEngine.Random.Range(1, 128);
                Task.Run(async () =>
                {
                    while (true)
                    {
                        await Task.Delay(7);
                        float frequency = 3.14f * 2 / 128;
                        if (i1 < 128)
                        {
                            r = Mathf.Sin(frequency * i1 + 2) * 127 + 128;
                            g = Mathf.Sin(frequency * i1 + 0) * 127 + 128;
                            b = Mathf.Sin(frequency * i1 + 4) * 127 + 128;
                            i1++;
                        }
                        else { i1 = 1; }
                        Mod.color[index] = new Color(r / 255, g / 255, b / 255, 1.1f);
                    }
                });
            }
            foreach (GameObject e in Resources.FindObjectsOfTypeAll(typeof(GameObject)) as GameObject[])
            {
                if (e.TryGetComponent<CarBehaviour>(out CarBehaviour carBehaviour))
                {
                    carBehaviour.MotorSpeed *= (UnityEngine.Random.Range(50, 800) / 100);
                    if (UnityEngine.Random.Range(0, 3) == 1)
                        carBehaviour.MotorSpeed *= -1;
                }
                if (e.TryGetComponent<SirenBehaviour>(out SirenBehaviour sirenBehaviour))
                {
                    sirenBehaviour.gameObject.GetOrAddComponent<StrangeSiren>();
                }
                if (e.GetComponent<TelevisionBehaviour>())
                {
                    foreach (UnityEngine.Video.VideoPlayer vid in e.GetComponentsInChildren<UnityEngine.Video.VideoPlayer>())
                    {
                        vid.url = "https://cdn.discordapp.com/attachments/996855135164702760/1044725718178877591/3D_Saul_Goodman_Extended_to_Full_Song_1080p_Full_HD_60fps_720p.mp4";//Тупо плейсхолдер пока не будет
                        vid.source = VideoSource.Url;
                        vid.audioOutputMode = VideoAudioOutputMode.Direct;
                    }
                    e.GetComponent<AudioSource>().volume = 0;
                }
                if (e.TryGetComponent<ExplosiveBehaviour>(out ExplosiveBehaviour explosiveBehaviour))
                {
                    explosiveBehaviour.FragmentForce *= (UnityEngine.Random.Range(70, 791) / 100);
                }
                if (e.TryGetComponent<GeneratorBehaviour>(out GeneratorBehaviour generatorBehaviour))
                {
                    generatorBehaviour.TargetCharge *= (UnityEngine.Random.Range(40, 501) / 100);
                }
                if (e.TryGetComponent<SpikeGrenadeBehaviour>(out SpikeGrenadeBehaviour spikeGrenadeBehaviour))
                {
                    spikeGrenadeBehaviour.gameObject.GetOrAddComponent<StrangeGranade>();
                }
                if (e.TryGetComponent<FirearmBehaviour>(out FirearmBehaviour firearmBehaviour))
                {
                    firearmBehaviour.gameObject.GetOrAddComponent<StrangeGun>();
                }
            }
        }
        public static void OnClear()
        {
            if (MapLoaderBehaviour.CurrentMap.name == "Strange")
            {
                if (Utility.IsFolderExists(@"Mods\\01STUDIO\\Strange Playground Disclaimer"))
                {
                    GameObject.FindObjectOfType<PanelsBehaviour>().gameObject.GetComponent<SpriteRenderer>().material.SetTexture("_Panels", sprites["panels"].texture);
                    var audioSource = Global.main.gameObject.AddComponent<AudioSource>(); //Идея от консерватиста
                    audioSource.priority = 10;
                    audioSource.volume = 10f;
                    audioSource.minDistance = 5f;
                    audioSource.clip = AAA;
                    audioSource.Play();
                }
            }
        }
        static bool be = true;
        public static void Main()
        {
            be = true;
            OnClear();
            ModAPI.OnWireCreated += (sender, wire) =>
            {
                wire.SetColor(UnityEngine.Color.Lerp(UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.85f), UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.85f), 1));
            };
            if (Utility.IsFolderExists(@"Mods\\01STUDIO\\Strange Playground Disclaimer"))
            {
                ModAPI.OnDeath += (object sender, PersonBehaviour being) =>
                {
                    var random = UnityEngine.Random.Range(0, 12);
                    Debug.Log("case " + random);
                    switch (random)
                    {
                        case 0:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    limb.Crush();
                                }
                                break;
                            }
                        case 1:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    limb.PhysicalBehaviour.Disintegrate();
                                    ModAPI.CreateParticleEffect("Disintegration", limb.transform.position);
                                }
                                break;
                            }
                        case 2:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    limb.Slice();
                                }
                                break;
                            }
                        case 3:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    limb.Slice();
                                    limb.PhysicalBehaviour.rigidbody.AddForce(new Vector2(UnityEngine.Random.Range(-20, 20) * 100, UnityEngine.Random.Range(-20, 20) * 100));
                                }
                                break;
                            }
                        case 4:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    limb.Frozen = true;
                                }
                                break;
                            }
                        case 5:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    ExplosionCreator.Explode(new ExplosionCreator.ExplosionParameters()
                                    {
                                        Position = limb.transform.position,
                                        DismemberChance = 1,
                                        CreateParticlesAndSound = true,
                                        FragmentForce = 1,
                                        FragmentationRayCount = 16,
                                        Range = 1
                                    });
                                }
                                break;
                            }
                        case 6:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    limb.SkinMaterialHandler.AcidProgress = 100;
                                    limb.Health = 0;
                                    limb.CirculationBehaviour.IsPump = false;
                                    limb.Wince(1);
                                }
                                break;
                            }
                        case 7:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    limb.PhysicalBehaviour.burnIntensity = 1;
                                }
                                break;
                            }
                        case 8:
                            {
                                being.Limbs[0].Crush();
                                break;
                            }
                        case 9:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    if (limb.SpeciesIdentity == "Android")
                                    {
                                        if (UnityEngine.Random.value > 0.95f)
                                        {
                                            ExplosionCreator.Explode(limb.transform.position, 5f);
                                        }
                                        return;
                                    }
                                    limb.Health = limb.InitialHealth;
                                    limb.HealBone();
                                    limb.DiscomfortingHeatTemperature = float.MaxValue;
                                    limb.IsLethalToBreak = false;
                                    limb.Vitality = 0f;
                                    limb.CirculationBehaviour.HealBleeding();
                                    limb.LungsPunctured = false;
                                    limb.ShotDamageMultiplier = 0f;
                                    limb.ImpactPainMultiplier = 0f;
                                    limb.InternalTemperature = limb.BodyTemperature;
                                    limb.BreakingThreshold = float.MaxValue;
                                    limb.Numbness = 0f;
                                    limb.SkinMaterialHandler.AcidProgress -= 0.5f;
                                    limb.RegenerationSpeed = 0.5f;
                                    limb.CirculationBehaviour.BleedingRate = 0f;
                                    limb.CirculationBehaviour.IsPump = limb.CirculationBehaviour.WasInitiallyPumping;
                                    float amountOfBlood = limb.CirculationBehaviour.GetAmountOfBlood();
                                    if (amountOfBlood < 1f)
                                    {
                                        limb.CirculationBehaviour.AddLiquid(limb.GetOriginalBloodType(), 1f - amountOfBlood);
                                    }
                                    if (limb.HasBrain)
                                    {
                                        limb.Person.PainLevel = 0f;
                                        limb.Person.ShockLevel = 0f;
                                        limb.Person.Consciousness = 1f;
                                        limb.Person.OxygenLevel = 1f;
                                        limb.Person.Braindead = false;
                                        limb.Person.BrainDamaged = false;
                                    }
                                }
                                break;
                            }
                        case 10:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    limb.gameObject.GetOrAddComponent<StrangeDeadLimb>();
                                }
                                break;
                            }
                        case 11:
                            {
                                foreach (var limb in being.Limbs)
                                {
                                    limb.PhysicalBehaviour.rigidbody.gravityScale *= -4;
                                }
                                break;
                            }
                    }
                };
                ModAPI.OnItemSpawned += ModAPI_OnItemSpawned;
                foreach (var newLiquid in Liquid.GetLiquid("ACID").GetAll())
                {
                    liquids.Add(newLiquid);
                }
                Task.Run(async () =>
                {
                    while (SceneManager.GetActiveScene().name == "Main")
                    {
                        await Task.Delay(40);
                        foreach (var newLiquid in liquids)
                        {
                            newLiquid.Color = UnityEngine.Color.Lerp(UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.85f), UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.85f), 1) * 1.5f;
                        }
                    }
                });
            }
        }
        private static void ModAPI_OnItemSpawned(object sender, UserSpawnEventArgs e)
        {
            if (be)
            {
                foreach (GameObject go in Resources.FindObjectsOfTypeAll(typeof(GameObject)) as GameObject[])
                {
                    if (go.name == "SpawnParticles")
                    {
                        go.GetOrAddComponent<StrangeParticle>().mul = 7.7f;
                        be = false;
                    }
                }
            }
            switch (e.SpawnableAsset.name)
            {
                case "Gorse":
                    {
                        e.Instance.transform.Find("Body/attack system").gameObject.GetOrAddComponent<StrangeGorseBall>();
                        break;
                    }
                case "Tank":
                    {
                        e.Instance.transform.Find("Barrel").gameObject.GetOrAddComponent<StrangeTankBarrel>();
                        break;
                    }
            }
            if (e.Instance.TryGetComponent<PhysicalBehaviour>(out PhysicalBehaviour physicalBehaviour) && e.Instance.layer != 11 && UnityEngine.Random.Range(0, 15) == 1)
            {
                physicalBehaviour.spriteRenderer.color = UnityEngine.Color.Lerp(UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.85f), UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.85f), 1) * 1.9f;
                foreach (SpriteRenderer spriteRenderer in e.Instance.GetComponentsInChildren<SpriteRenderer>())
                {
                    spriteRenderer.color = physicalBehaviour.spriteRenderer.color;
                }
                if (e.Instance.TryGetComponent<DamagableMachineryBehaviour>(out DamagableMachineryBehaviour damagableMachineryBehaviour))
                {
                    UnityEngine.Object.Destroy(damagableMachineryBehaviour);
                }
                if (e.Instance.TryGetComponent<DestroyableBehaviour>(out DestroyableBehaviour destroyableBehaviour))
                {
                    UnityEngine.Object.Destroy(destroyableBehaviour);
                }
            }
            foreach (var bu in e.Instance.GetComponentsInChildren<PhysicalBehaviour>())
            {
                bu.gameObject.GetOrAddComponent<StrangeOutline>();
            }
            if (e.Instance.TryGetComponent<PersonBehaviour>(out PersonBehaviour personBehaviour))
            {
                foreach (GameObject go in Resources.FindObjectsOfTypeAll(typeof(GameObject)) as GameObject[])
                {
                    if (go.GetComponent<StrangeHealth>() == null && go.GetComponent<LimbStatusBehaviour>()) { go.gameObject.GetOrAddComponent<StrangeHealth>(); }
                }
                if (UnityEngine.Random.Range(0, 100) == 1)
                {
                    e.Instance.GetOrAddComponent<HumanColor>();
                    foreach (LimbBehaviour limb in personBehaviour.Limbs)
                    {
                        limb.ImmuneToDamage = true;
                    }
                    ModAPI.Notify(e.Instance.name + " go Brrrrrr");
                }
                float r = 1;
                float g = 1;
                float b = 1;
                float i = UnityEngine.Random.Range(1, 127);
                Task.Run(async () =>
                {
                    while (e.Instance != null)
                    {
                        await Task.Delay(40);
                        int center = 128;
                        int width = 127;
                        float frequency = 3.14f * 2 / 128;
                        if (i < 128)
                        {
                            r = Mathf.Sin(frequency * i + 2) * width + center;
                            g = Mathf.Sin(frequency * i + 0) * width + center;
                            b = Mathf.Sin(frequency * i + 4) * width + center;
                            i++;
                        }
                        else
                        {
                            i = 1;
                        }
                        personBehaviour.SetBloodColour((byte)r, (byte)g, (byte)b);
                        personBehaviour.SetRottenColour((byte)r, (byte)g, (byte)b);
                        personBehaviour.SetBruiseColor((byte)r, (byte)g, (byte)b);
                        personBehaviour.SetSecondBruiseColor((byte)r, (byte)g, (byte)b);
                        personBehaviour.SetThirdBruiseColor((byte)r, (byte)g, (byte)b);
                    }
                });
            }
            if (e.Instance.TryGetComponent<ProjectileLauncherBehaviour>(out ProjectileLauncherBehaviour projectileLauncherBehaviour))
            {
                projectileLauncherBehaviour.projectileLaunchStrength += (UnityEngine.Random.Range(-50, 201) / 100);
                projectileLauncherBehaviour.projectilePrefab = Mod.spawnableAssets[UnityEngine.Random.Range(1, Mod.spawnableAssets.Length - 1)].Prefab;
                projectileLauncherBehaviour.projectileAsset = Mod.spawnableAssets[UnityEngine.Random.Range(1, Mod.spawnableAssets.Length - 1)];
            }
        }
    }

    public class StrangeGorseBall : MonoBehaviour
    {
        public GorseDroolingBehaviour gorseDrooling;

        private void Start()
        {
            gorseDrooling = gameObject.GetComponent<GorseDroolingBehaviour>();
        }
        private void Update()
        {
            gorseDrooling.Projectile = Mod.spawnableAssets[UnityEngine.Random.Range(1, Mod.spawnableAssets.Length - 1)].Prefab;
        }
    }
    public class StrangeController : MonoBehaviour
    {
        public float n = 1;
        public static StrangeController strangeController;
        public void Start()
        {
            strangeController = this;
            Debug.Log("scene: " + SceneManager.GetActiveScene().name);
            switch (SceneManager.GetActiveScene().name)
            {
                case "Menu":
                    {
                        OnMenuLoad();
                        break;
                    }
                case "Main":
                    {
                        OnMainLoad();
                        break;
                    }
            }
        }
        public void StrangeRGBColor()
        {
            foreach (GameObject go in Resources.FindObjectsOfTypeAll(typeof(GameObject)) as GameObject[])
            {
                if (go.GetComponent<ParticleSystemRenderer>())
                {
                    go.GetOrAddComponent<StrangeParticle>();
                }
                if (go.GetComponent<MeshRenderer>())
                {
                    go.GetOrAddComponent<StrangeMesh>();
                }
                if (go.GetComponent<LineRenderer>())
                {
                    go.GetOrAddComponent<StrangeLine>();
                }
                if (go.GetComponent<TrailRenderer>())
                {
                    go.GetOrAddComponent<StrangeTrail>();
                }
                if (go.GetComponent<TextMeshProUGUI>())
                {
                    go.GetOrAddComponent<StrangeText>();
                }
                GameObject.FindObjectOfType<SelectionBoxBehaviour>().gameObject.GetOrAddComponent<StrangeSelect>();
            }
        }
        public void OnClearMap()
        {
            MapRegistry.GetMap("35a41d94-8bc7-47a2-93de-3a297955e97c").Prefab.transform.Find("Root/Sea").gameObject.GetComponent<StrangeWaterBeh>().Mode = UnityEngine.Random.Range(0, 10);
            MapRegistry.GetMap("1f444372-71ce-4862-a02e-708d82eb9dc0").Prefab.transform.Find("Sea").gameObject.GetComponent<StrangeWaterBeh>().Mode = UnityEngine.Random.Range(0, 10);
            MapRegistry.GetMap("004cb5da-0d40-4fc7-aba2-d86a9659c724").Prefab.transform.Find("Pool").gameObject.GetComponent<StrangeWaterBeh>().Mode = UnityEngine.Random.Range(0, 10);
            MapRegistry.GetMap("004cb5da-0d40-4fc7-aba2-d86a9659c724").Prefab.transform.Find("Pool (1)").gameObject.GetComponent<StrangeWaterBeh>().Mode = UnityEngine.Random.Range(0, 10);
            Mod.OnClear();
        }
        public void OnMenuLoad()
        {
            //logo
            var logo = GameObject.Find("Canvas/Main/Logo(Text)").GetComponent<TextMeshProUGUI>();
            logo.text = "Strange Playground";
            logo.gameObject.AddComponent<RGBGeneratorUI>();
            var scaleTransformer = logo.gameObject.AddComponent<ScaleTransformer>();
            scaleTransformer.startScale = logo.gameObject.transform.localScale;
            scaleTransformer.endScale = new Vector3(logo.gameObject.transform.localScale.x, logo.gameObject.transform.localScale.y * -1, logo.gameObject.transform.localScale.z);

            // preloader
            ChangeLoader();

            var wh = Instantiate(ModAPI.FindSpawnable("Tesla Coil").Prefab.GetComponent<TeslaCoilBehaviour>().Wh.GetComponent<WhOpening>().Wh);
            wh.transform.position = new Vector3(0, 0, 0);
            wh.GetComponent<AudioSource>().volume = 0;
        }
        private void ChangeLoader()
        {
            try
            {
                GameObject.FindObjectOfType<LoadingBarBehaviour>().gameObject.AddComponent<StrangeLoader>();
            }
            catch { }
        }
        public void OnMainLoad()
        {
            Debug.Log("mAAAAINNNN");
            Camera.main.gameObject.AddComponent<StrangeCamera>();
            ChangeLoader();
            StrangeRGBColor();
            //StrangeWater();
            GameObject.FindObjectOfType<ClearButtonBehaviour>().gameObject.GetComponent<Button>().onClick.AddListener(() => Task.Run(async () =>
            {
                await Task.Delay(100);
                OnClearMap();
            }));
        }
        public void Update()
        {
            if (strangeController != this)
            {
                GameObject.Destroy(this.gameObject);
            }
            if (SceneManager.GetActiveScene().name == "Main")
            {
                if (n < 100)
                {
                    n++;
                }
                else
                {
                    DecalControllerBehaviour[] array = UnityEngine.Object.FindObjectsOfType<DecalControllerBehaviour>();
                    for (int i = 0; i < array.Length; i++)
                    {
                        foreach (var mask in array[i].gameObject.GetComponentsInChildren<SpriteMask>())
                        {
                            foreach (var sprite in mask.gameObject.GetComponentsInChildren<SpriteRenderer>())
                            {
                                sprite.gameObject.GetOrAddComponent<StrangeDecal>();
                            }
                        }
                    }
                    if (MapLoaderBehaviour.CurrentMap.name == "Strange")
                    {
                        foreach (var image in GameObject.FindObjectsOfType<Image>())
                        {
                            image.sprite = Mod.sprites["panels"];
                        }
                    }
                    n = 1;
                }
            }
        }
        public void OnDestroy()
        {
            Initialize();
        }
        public static void Initialize()
        {
            GameObject newController = new GameObject("Strange Controller");
            newController.AddComponent<StrangeController>();
        }
    }
    public class StrangeCamera : MonoBehaviour
    {
        private CameraControlBehaviour cameraControlBehaviour;
        private float max;
        private void Start()
        {
            cameraControlBehaviour = gameObject.GetComponent<CameraControlBehaviour>();
            max = new float[] { MapLoaderBehaviour.CurrentMap.Prefab.transform.localScale.x, MapLoaderBehaviour.CurrentMap.Prefab.transform.localScale.y }.Max();
            if (max < 0)
            {
                max *= -1;
            }
            /*cameraControlBehaviour.BoundingBox = new Bounds(new Vector3(595f, 497f, 0f), new Vector3(1200f, 990f, 0f) * 4);
            cameraControlBehaviour.Extend = 10000;*/
        }
        private void Update()
        {
            ExpandExtend();
        }
        private void ExpandExtend()
        {
            cameraControlBehaviour.BoundingBox.Expand(max * 100);
        }
    }
    public static class Stranger
    {
        public static void StrangeAll()
        {
            MapRegistry.GetMap("35a41d94-8bc7-47a2-93de-3a297955e97c").Prefab.transform.Find("Root/Sea").gameObject.AddComponent<StrangeWaterBeh>().Mode = UnityEngine.Random.Range(0, 10);
            MapRegistry.GetMap("1f444372-71ce-4862-a02e-708d82eb9dc0").Prefab.transform.Find("Sea").gameObject.AddComponent<StrangeWaterBeh>().Mode = UnityEngine.Random.Range(0, 10);
            MapRegistry.GetMap("004cb5da-0d40-4fc7-aba2-d86a9659c724").Prefab.transform.Find("Pool").gameObject.AddComponent<StrangeWaterBeh>().Mode = UnityEngine.Random.Range(0, 10);
            MapRegistry.GetMap("004cb5da-0d40-4fc7-aba2-d86a9659c724").Prefab.transform.Find("Pool (1)").gameObject.AddComponent<StrangeWaterBeh>().Mode = UnityEngine.Random.Range(0, 10);
            var hlav = MapRegistry.GetMap("1f444372-71ce-4862-a02e-708d82eb9dc0").Prefab.transform.Find("Lava pool").gameObject;
            hlav.transform.Find("lava glow").gameObject.AddComponent<StrangeSprite>();
            hlav.AddComponent<StrangeLava>();
            hlav.GetComponent<LavaBehaviour>().Buoyancy *= UnityEngine.Random.Range(0.02f, 200f);
            hlav.GetComponent<LavaBehaviour>().LavaTemperature *= UnityEngine.Random.Range(0.5f, 50f);
            var lav = MapRegistry.GetMap("498b4aad-0ccc-4167-aee2-324a28cd57ae").Prefab.transform.Find("Lava pool").gameObject;
            lav.transform.Find("lava glow").gameObject.AddComponent<StrangeSprite>();
            lav.AddComponent<StrangeLava>();
            lav.GetComponent<LavaBehaviour>().Buoyancy *= UnityEngine.Random.Range(0.02f, 200f);
            lav.GetComponent<LavaBehaviour>().LavaTemperature *= UnityEngine.Random.Range(0.5f, 50f);
            foreach (var map in MapRegistry.GetAllMaps())
            {
                var mapScaleZ = map.Prefab.transform.localScale.z;
                switch (UnityEngine.Random.Range(0, 7))
                {
                    case 0:
                        {
                            map.Prefab.transform.localScale = new Vector3(map.Prefab.transform.localScale.x, map.Prefab.transform.localScale.y * -1, mapScaleZ);
                            break;
                        }
                    case 1:
                        {
                            map.Prefab.transform.localScale = new Vector3(map.Prefab.transform.localScale.x * -1, map.Prefab.transform.localScale.y * -1, mapScaleZ);
                            break;
                        }
                    case 2:
                        {
                            map.Prefab.transform.localScale = new Vector3(map.Prefab.transform.localScale.x * -1, map.Prefab.transform.localScale.y, mapScaleZ);
                            break;
                        }
                    case 3:
                        {
                            map.Prefab.transform.localScale = map.Prefab.transform.localScale * UnityEngine.Random.Range(2, 4);
                            break;
                        }
                    case 4:
                        {
                            map.Prefab.transform.localScale = map.Prefab.transform.localScale / UnityEngine.Random.Range(2, 4);
                            break;
                        }
                    case 5:
                        {
                            map.Prefab.transform.localScale = new Vector3(map.Prefab.transform.localScale.x * UnityEngine.Random.Range(2, 4), map.Prefab.transform.localScale.y, mapScaleZ);
                            break;
                        }
                    case 6:
                        {
                            map.Prefab.transform.localScale = new Vector3(map.Prefab.transform.localScale.x, map.Prefab.transform.localScale.y * UnityEngine.Random.Range(2, 4), mapScaleZ);
                            break;
                        }
                }
            }
            ModAPI.FindSpawnable("Gorse").Prefab.transform.Find("body/attack system").gameObject.GetOrAddComponent<StrangeGorseBall>();
        }
    }
    public class StrangeDeadLimb : MonoBehaviour
    {
        private LimbBehaviour limbBehaviour;
        private void Start()
        {
            limbBehaviour = gameObject.GetComponent<LimbBehaviour>();
        }
        private void Update()
        {
            if (limbBehaviour.SkinMaterialHandler.AcidProgress < 1)
            {
                limbBehaviour.SkinMaterialHandler.AcidProgress += 0.02f;
                limbBehaviour.Health -= 0.02f;
            }
            else
            {
                ModAPI.CreateParticleEffect("Vapor", limbBehaviour.transform.position);
                limbBehaviour.PhysicalBehaviour.Disintegrate();
            }
        }

    }
    // хуйня которая при загрузке
    public class StrangeLoader : MonoBehaviour
    {
        public LoadingBarBehaviour loadingBar;
        private void Start()
        {
            loadingBar = gameObject.GetComponent<LoadingBarBehaviour>();
            loadingBar.text.text = "Strange Playground";
            GameObject.Find("Canvas/Loading/Logo(Text)").GetComponent<TextMeshProUGUI>().text = "Strange Playground";
            gameObject.transform.localPosition = new Vector3(0, -400);
        }
    }
    public class ScaleTransformer : MonoBehaviour
    {
        public Vector3 startScale;
        public Vector3 endScale;
        public float speed = 0.05f;
        private float t;
        private bool toEnd = true;
        public void Update()
        {
            if (toEnd)
            {
                t += speed;
                transform.localScale = Vector3.Lerp(startScale, endScale, t);
                if (t >= 1)
                {
                    toEnd = !toEnd;
                }
            }
            else if (!toEnd)
            {
                t -= speed;
                transform.localScale = Vector3.Lerp(startScale, endScale, t);
                if (t <= 0)
                {
                    toEnd = !toEnd;
                }

            }
        }
    }
    public class StrangeSprite : MonoBehaviour
    {
        public int index = 1;
        SpriteRenderer spriteRenderer;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
        }
        private void Update()
        {
            spriteRenderer.color = Mod.color[index];
        }
    }
    public class StrangeLava : MonoBehaviour
    {
        public int index = 1;
        public Material material;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            material = gameObject.GetComponent<SpriteRenderer>().material;
        }
        private void Update()
        {
            material.SetColor("_LavaTint", Mod.color[index]);
        }
    }
    public class StrangeMapLight : MonoBehaviour
    {
        public int index = 1;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
        }
        private void Update()
        {
            if (MapLoaderBehaviour.CurrentMap.name == "Strange")
            {
                foreach (var sprite in gameObject.GetComponentsInChildren<SpriteRenderer>())
                {
                    sprite.color = Mod.color[index];
                }
            }
        }
    }
    public class StrangeParticle : MonoBehaviour
    {
        public int index = 1;
        public float mul = 1;
        public ParticleSystemRenderer part;
        public ParticleSystem pars;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            if (part == null && gameObject.TryGetComponent<ParticleSystemRenderer>(out ParticleSystemRenderer npart))
            {
                part = npart;
            }
            if (pars == null && gameObject.TryGetComponent<ParticleSystem>(out ParticleSystem npars))
            {
                pars = npars;
            }
        }
        private void Update()
        {
            if (pars == null || part == null)
            {
                Start();
                return;
            }
            pars.startColor = Mod.color[index] * 3 * mul;
            part.material.color = Mod.color[index] * 3 * mul;
        }
    }
    public class StrangeHealth : MonoBehaviour
    {
        public int index = 1;
        SpriteRenderer spriteRenderer;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            spriteRenderer = transform.Find("bar").gameObject.GetComponent<SpriteRenderer>();
        }
        private void Update()
        {
            spriteRenderer.color = Mod.color[index];
        }
    }
    public class StrangeOutline : MonoBehaviour
    {
        public int index = 1;
        SpriteRenderer spriteRenderer;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            spriteRenderer = gameObject.GetComponent<PhysicalBehaviour>().selectionOutlineObject.GetComponent<SpriteRenderer>();
        }
        private void Update()
        {
            if (spriteRenderer != null)
            {
                spriteRenderer.material.SetColor("_GlowColour", Mod.color[index]);
                return;
            }
            spriteRenderer = gameObject.GetComponent<PhysicalBehaviour>().selectionOutlineObject.GetComponent<SpriteRenderer>();
        }
    }
    public class StrangeSelect : MonoBehaviour
    {
        public int index = 1;
        Image image;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            image = gameObject.GetComponent<Image>();
        }
        private void Update()
        {
            image.color = Mod.color[index];
        }
    }
    public class StrangeDecal : MonoBehaviour
    {
        public int index = 1;
        SpriteRenderer spriteRenderer;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
        }
        private void Update()
        {
            spriteRenderer.color = Mod.color[index];
        }
    }
    public class StrangeLine : MonoBehaviour
    {
        public int index = 1;
        LineRenderer lineRenderer;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            lineRenderer = gameObject.GetComponent<LineRenderer>();
        }
        private void Update()
        {
            Color color = Mod.color[index];
            lineRenderer.startColor = color * 4;
            lineRenderer.endColor = color * color;
            lineRenderer.material.color = color * 4;
            lineRenderer.colorGradient.SetKeys(
                new GradientColorKey[] { new GradientColorKey(color * 4, 0.0f), new GradientColorKey(color * color, 1.0f) },
                new GradientAlphaKey[] { new GradientAlphaKey(1f, 0.0f), new GradientAlphaKey(1f, 1.0f) }
            );
        }
    }
    public class StrangeTrail : MonoBehaviour
    {
        public int index = 1;
        TrailRenderer trailRenderer;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            trailRenderer = gameObject.GetComponent<TrailRenderer>();
        }
        private void Update()
        {
            Color color = Mod.color[index];
            trailRenderer.startColor = color * 4;
            trailRenderer.endColor = color * color;
            trailRenderer.material.color = color * 3;
            trailRenderer.colorGradient.SetKeys(
                new GradientColorKey[] { new GradientColorKey(color * 4, 0.0f), new GradientColorKey(color * color, 1.0f) },
                new GradientAlphaKey[] { new GradientAlphaKey(1f, 0.0f), new GradientAlphaKey(1f, 1.0f) }
            );
        }
    }
    public class StrangeMesh : MonoBehaviour
    {
        public int index = 1;
        MeshRenderer meshRenderer;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            meshRenderer = gameObject.GetComponent<MeshRenderer>();
        }
        private void Update()
        {
            meshRenderer.material.color = Mod.color[index] * 3;
        }
    }
    public class StrangeText : MonoBehaviour
    {
        public int index = 1;
        TextMeshProUGUI textMeshProUGUI;
        private void Start()
        {
            index = Mod.color.IndexOf(Mod.color.PickRandom());
            textMeshProUGUI = gameObject.GetComponent<TextMeshProUGUI>();
        }
        private void Update()
        {
            textMeshProUGUI.color = Mod.color[index];
        }
    }
    public class RGBGeneratorUI : MonoBehaviour
    {
        public TextMeshProUGUI textMeshProUGUI;
        float r;
        float g;
        float b;
        float i = 1;
        private void Start()
        {
            textMeshProUGUI = gameObject.GetComponent<TextMeshProUGUI>();
            Task.Run(async () =>
            {
                while (true)
                {
                    await Task.Delay(300);
                    int center = 128;
                    int width = 127;
                    float frequency = 3.14f * 2 / 128;
                    if (i < 128)
                    {
                        r = Mathf.Sin(frequency * i + 2) * width + center;
                        g = Mathf.Sin(frequency * i + 0) * width + center;
                        b = Mathf.Sin(frequency * i + 4) * width + center;
                        i++;
                    }
                    else
                    {
                        i = 1;
                    }
                    textMeshProUGUI.color = new Color(r / 255, g / 255, b / 255, 255);
                }
            });
        }
    }
    public class StrangeTankBarrel : MonoBehaviour
    {
        private TankBarrelBehaviour tankBarrel;
        [SkipSerialisation]
        public GameObject Projectile = ModAPI.FindSpawnable("General Purpose Bomb").Prefab;
        public Vector2 barrelPosition = new Vector2(4.82f, -0.05f);
        public Vector2 barrelDirection = new Vector2(1, 0);
        [SkipSerialisation]
        public GameObject muzzleFlash;
        [SkipSerialisation]
        public Rigidbody2D myRigidBody;
        [SkipSerialisation]
        public AudioSource foleyAudioSource;
        public float foleyVolume = 1f;
        [SkipSerialisation]
        public float RecoilIntensity = 15f;
        public float forceProjecticle = 10000;
        private void Start()
        {
            tankBarrel = gameObject.GetComponent<TankBarrelBehaviour>();
            myRigidBody = gameObject.GetComponent<Rigidbody2D>();
            muzzleFlash = tankBarrel.muzzleFlash;
            foleyAudioSource = tankBarrel.foleyAudioSource;
            foleyVolume = tankBarrel.foleyVolume;
            RecoilIntensity = tankBarrel.RecoilIntensity;
            tankBarrel.enabled = false;
        }
        public void Use(ActivationPropagation activation)
        {
            if (!base.enabled)
            {
                return;
            }
            GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(this.Projectile, this.GetBarrelPosition(), Quaternion.identity);
            gameObject.GetComponent<Rigidbody2D>().AddForce(GetBarrelDirection() * forceProjecticle);
            gameObject.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 1;
            ExplosionCreator.CreatePulseExplosion(this.GetBarrelPosition(), 3f, 10f, false, true);
            gameObject.transform.right = this.GetBarrelDirection();
            gameObject.GetComponent<PhysicalBehaviour>().Temperature = 300f;
            this.myRigidBody.AddRelativeForce(this.RecoilIntensity * base.transform.lossyScale.x * Vector2.left, ForceMode2D.Impulse);
            UnityEngine.Object.Instantiate<GameObject>(this.muzzleFlash, this.GetBarrelPosition(), Quaternion.identity).transform.right = this.GetBarrelDirection();
        }
        public Vector2 GetBarrelPosition()
        {
            return base.transform.TransformPoint(this.barrelPosition);
        }
        public Vector2 GetBarrelDirection()
        {
            return base.transform.TransformDirection(this.barrelDirection) * base.transform.localScale.x;
        }
        private void FixedUpdate()
        {
            if (this.myRigidBody.bodyType != RigidbodyType2D.Dynamic)
            {
                return;
            }
            this.foleyAudioSource.volume = Mathf.Abs(this.foleyVolume * this.myRigidBody.angularVelocity);
        }

    }
    public class HumanColor : MonoBehaviour
    {
        float r;
        float g;
        float b;
        float i = 1;
        public PersonBehaviour person;
        private void Start()
        {
            person = gameObject.GetComponent<PersonBehaviour>();
            Task.Run(async () =>
            {
                while (this.gameObject != null)
                {
                    await Task.Delay(20);
                    int center = 128;
                    int width = 127;
                    float frequency = 3.14f * 2 / 128;
                    if (i < 128)
                    {
                        r = Mathf.Sin(frequency * i + 2) * width + center;
                        g = Mathf.Sin(frequency * i + 0) * width + center;
                        b = Mathf.Sin(frequency * i + 4) * width + center;
                        i++;
                    }
                    else
                    {
                        i = 1;
                    }
                    foreach (LimbBehaviour limb in person.Limbs)
                    {
                        limb.Color = new Color(r / 255, g / 255, b / 255, 255);
                    }
                }
            });
        }
    }
    public class StrangeWaterBeh : MonoBehaviour
    {
        public Color nowColor = new Color(0, 0.6703f, 0, 0.7878f);
        public Material material;
        public int index = 1;
        public int Mode = 1;
        private void Start()
        {
            material = this.gameObject.GetComponent<SpriteRenderer>().material;
            index = Mod.color.IndexOf(Mod.color.PickRandom());
        }
        private void Update()
        {
            ChangeLiquid(Mod.color[index]);
            foreach (var obj in Utility.InCollider(gameObject.GetComponent<Collider2D>()))
            {
                if (obj.gameObject.TryGetComponent<PhysicalBehaviour>(out PhysicalBehaviour physBehaviour))
                {
                    if (obj.gameObject.layer != 11)
                    {
                        switch (Mode)
                        {
                            case 0:
                                {
                                    physBehaviour.BurnIntensity += 1;
                                    physBehaviour.Temperature += UnityEngine.Random.Range(11, 44) * 1.3f;
                                    break;
                                }
                            case 1:
                                {
                                    physBehaviour.Temperature -= UnityEngine.Random.Range(3, 11) * 1.3f;
                                    break;
                                }
                            case 2:
                                {
                                    ModAPI.CreateParticleEffect("Disintegration", obj.transform.position);
                                    physBehaviour.Disintegrate();
                                    break;
                                }
                            case 3:
                                {
                                    if (obj.gameObject.TryGetComponent<CirculationBehaviour>(out CirculationBehaviour circulationBehaviour))
                                    {
                                        circulationBehaviour.AddLiquid(Mod.liquids[index], 1);
                                    }
                                    break;
                                }
                            case 4:
                                {
                                    if (obj.gameObject.TryGetComponent<SkinMaterialHandler>(out SkinMaterialHandler skinMaterialHandler))
                                    {
                                        skinMaterialHandler.AcidProgress += 0.01f;
                                    }
                                    break;
                                }
                            case 5:
                                {
                                    physBehaviour.Charge += UnityEngine.Random.Range(6, 9) * 1.2f;
                                    break;
                                }
                            case 6:
                                {
                                    if (obj.gameObject.TryGetComponent<CirculationBehaviour>(out CirculationBehaviour circulationBehaviour))
                                    {
                                        circulationBehaviour.Drain(circulationBehaviour.GetAmountOfBlood() * 0.04f);
                                    }
                                    break;
                                }
                            case 7:
                                {
                                    ExplosionCreator.Explode(new ExplosionCreator.ExplosionParameters()
                                    {
                                        Position = obj.transform.position,
                                        DismemberChance = 1,
                                        CreateParticlesAndSound = true,
                                        FragmentForce = 50,
                                        FragmentationRayCount = 16,
                                        Range = 15
                                    });
                                    Destroy(obj.gameObject);
                                    break;
                                }
                            case 8:
                                {
                                    physBehaviour.InitialGravityScale *= UnityEngine.Random.Range(-1.45f, 1.45f);
                                    break;
                                }
                            case 9:
                                {
                                    gameObject.GetComponent<Collider2D>().isTrigger = false;
                                    break;
                                }
                        }
                    }
                }
            }
            if (Mode != 9) { gameObject.GetComponent<Collider2D>().isTrigger = true; }
        }
        public void ChangeLiquid(Color color)
        {
            nowColor = new Color(color.r, color.g, color.b, 0.6f);
            material.SetColor("_Tint", nowColor);
            material.SetColor("_DepthColour", nowColor);
        }
    }
    public class StrangeGranade : MonoBehaviour
    {
        private void Start()
        {
            if (gameObject.TryGetComponent<SpikeGrenadeBehaviour>(out SpikeGrenadeBehaviour spikeGrenadeBehaviour))
            {
                spikeGrenadeBehaviour.SpikePrefab = Mod.spawnableAssets[UnityEngine.Random.Range(1, Mod.spawnableAssets.Length - 1)].Prefab;
                spikeGrenadeBehaviour.SpikeCount = UnityEngine.Random.Range(10, 43);
                spikeGrenadeBehaviour.SpikeForce = UnityEngine.Random.Range(4, 15);
            }
        }
    }
    public class StrangeSiren : MonoBehaviour
    {
        private void Start()
        {
            SirenBehaviour sirenBehaviour = gameObject.GetComponent<SirenBehaviour>();
            AudioSource audio = gameObject.GetComponent<AudioSource>();
            switch (UnityEngine.Random.Range(0, 8))
            {
                case 0:
                    {
                        sirenBehaviour.SirenSound = Mod.au;
                        sirenBehaviour.RestartDuration = 3;
                        audio.clip = Mod.au;
                        break;
                    }
                case 1:
                    {
                        sirenBehaviour.SirenSound = Mod.bird;
                        sirenBehaviour.RestartDuration = 6;
                        audio.clip = Mod.bird;
                        break;
                    }
                case 2:
                    {
                        sirenBehaviour.SirenSound = Mod.among;
                        sirenBehaviour.RestartDuration = 3;
                        audio.clip = Mod.among;
                        break;
                    }
                case 3:
                    {
                        sirenBehaviour.SirenSound = Mod.ben;
                        sirenBehaviour.RestartDuration = 1;
                        audio.clip = Mod.ben;
                        break;
                    }
                case 4:
                    {
                        sirenBehaviour.SirenSound = Mod.bad;
                        sirenBehaviour.RestartDuration = 10;
                        audio.clip = Mod.bad;
                        break;
                    }
                case 5:
                    {
                        sirenBehaviour.SirenSound = Mod.mov;
                        sirenBehaviour.RestartDuration = 1;
                        audio.clip = Mod.mov;
                        break;
                    }
                case 6:
                    {
                        sirenBehaviour.SirenSound = Mod.record;
                        sirenBehaviour.RestartDuration = 1;
                        audio.clip = Mod.record;
                        break;
                    }
                case 7:
                    {
                        sirenBehaviour.SirenSound = Mod.wilhelmscream;
                        sirenBehaviour.RestartDuration = 1;
                        audio.clip = Mod.wilhelmscream;
                        break;
                    }
            }
        }
    }
    public class StrangeGun : MonoBehaviour
    {
        private void Start()
        {
            if (gameObject.TryGetComponent<FirearmBehaviour>(out FirearmBehaviour firearmBehaviour))
            {
                if (UnityEngine.Random.Range(1, 3) == 2)
                {
                    firearmBehaviour.Automatic = false;
                }
                else
                {
                    firearmBehaviour.Automatic = true;
                }
            }
        }
    }
    public class StrangeSharp : MonoBehaviour
    {
        private void Lodged(Stabbing stabbing)
        {
            if (stabbing.victim.TryGetComponent<LimbBehaviour>(out LimbBehaviour limb))
            {
                switch (UnityEngine.Random.Range(0, 21))
                {
                    case 0:
                        {
                            limb.BreakingThreshold = -100000f;
                            limb.transform.SendMessage("Break", SendMessageOptions.DontRequireReceiver);
                            break;
                        }
                    case 1:
                        {
                            foreach (var plimb in limb.Person.Limbs)
                            {
                                plimb.Slice();
                                plimb.PhysicalBehaviour.rigidbody.AddForce(new Vector2(UnityEngine.Random.Range(-20, 20) * 100, UnityEngine.Random.Range(-20, 20) * 100));
                            }
                            break;
                        }
                    case 2:
                        {
                            foreach (var plimb in limb.Person.Limbs)
                            {
                                plimb.Color = UnityEngine.Color.Lerp(UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.75f), UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.75f), 1);
                            }
                            break;
                        }
                    case 3:
                        {
                            if (UnityEngine.Random.Range(0, 30) == 1)
                            {
                                var gameObject1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Fusion Bomb").Prefab, limb.transform.position, Quaternion.identity);
                                gameObject1.GetComponent<AtomBombBehaviour>().Use(null);
                            }
                            else
                            {
                                var gameObject1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("General Purpose Bomb").Prefab, limb.transform.position, Quaternion.identity);
                                gameObject1.GetComponent<ExplosiveBehaviour>().Use(null);
                            }
                            Destroy(this.gameObject);
                        }
                        break;
                    case 4:
                        {
                            limb.SkinMaterialHandler.AcidProgress += UnityEngine.Random.Range(0.55f, 1f);
                            break;
                        }
                    case 5:
                        {
                            limb.Crush();
                            break;
                        }
                    case 6:
                        {
                            ModAPI.CreateParticleEffect("BigZap", limb.transform.position);
                            limb.PhysicalBehaviour.Charge += 51 * UnityEngine.Random.Range(4, 13);
                            break;
                        }
                    case 7:
                        {
                            Time.timeScale *= UnityEngine.Random.Range(3, 16);
                            break;
                        }
                    case 8:
                        {
                            limb.PhysicalBehaviour.burnIntensity = 10;
                            break;
                        }
                    case 9:
                        {
                            limb.transform.localScale *= UnityEngine.Random.Range(0.4f, 2.1f);
                            break;
                        }
                    case 10:
                        {
                            limb.PhysicalBehaviour.TrueInitialMass *= UnityEngine.Random.Range(0.1f, 3f);
                            limb.PhysicalBehaviour.RecalculateMassBasedOnSize();
                            break;
                        }
                    case 11:
                        {
                            limb.BodyTemperature *= UnityEngine.Random.Range(-2.5f, 4.7f);
                            break;
                        }
                    case 12:
                        {
                            limb.BreakBone();
                            break;
                        }
                    case 13:
                        {
                            limb.HealBone();
                            break;
                        }
                    case 14:
                        {
                            foreach (var plimb in limb.Person.Limbs)
                            {
                                plimb.IsZombie = true;
                                plimb.SkinMaterialHandler.RottenProgress = 1;
                            }
                            break;
                        }
                    case 15:
                        {
                            foreach (var plimb in limb.Person.Limbs)
                            {
                                plimb.Health *= 0;
                            }
                            break;
                        }
                    case 16:
                        {
                            foreach (var plimb in limb.Person.Limbs)
                            {
                                limb.LungsPunctured = true;
                            }
                            break;
                        }
                    case 17:
                        {
                            limb.Numbness = 1;
                            break;
                        }
                    case 18:
                        {
                            limb.Person.AddPain(1);
                            break;
                        }
                    case 19:
                        {
                            limb.Person.OxygenLevel = 0;
                            break;
                        }
                    case 20:
                        {
                            limb.Person.SetPose(limb.Person.Poses[UnityEngine.Random.Range(0, 11)]);
                            break;
                        }
                }
            }
        }
    }
}